local M = {}

local lCannonFireCount = 0
local rCannonFireCount = 0
local lCannonFireActive = 0
local rCannonFireActive = 0
local LastCannonPitch = 0


local function onInit()
	
	lCannonFireCount = 0
	rCannonFireCount = 0
	lCannonFireActive = 0
	rCannonFireActive = 0
	LastCannonPitch = 0
	
	electrics.values['lCannon1'] = 0
	electrics.values['lCannon2'] = 0
	electrics.values['lCannon3'] = 0
	electrics.values['rCannon1'] = 0
	electrics.values['rCannon2'] = 0
	electrics.values['rCannon3'] = 0
end

local function onUpdate()

	electrics.values['cannonPitch'] = LastCannonPitch

	if electrics.values['portguns_fire'] == 1 and lCannonFireActive == 0 then
		lCannonFireActive = 1
	elseif electrics.values['portguns_fire'] == 0 and lCannonFireActive == 1 then
		lCannonFireCount = lCannonFireCount + 1
		lCannonFireActive = 0
	end
	
	if electrics.values['starguns_fire'] == 1 and rCannonFireActive == 0 then
		rCannonFireActive = 1
	elseif electrics.values['starguns_fire'] == 0 and rCannonFireActive == 1 then
		rCannonFireCount = rCannonFireCount + 1
		rCannonFireActive = 0
	end
	
	if lCannonFireActive == 1 then
		if lCannonFireCount == 0 then
			electrics.values['lCannon1'] = 1
		elseif lCannonFireCount == 1 then
			electrics.values['lCannon2'] = 1
		elseif lCannonFireCount == 2 then
			electrics.values['lCannon3'] = 1
		end
	end
	
	if rCannonFireActive == 1 then
		if rCannonFireCount == 0 then
			electrics.values['rCannon1'] = 1
		elseif rCannonFireCount == 1 then
			electrics.values['rCannon2'] = 1
		elseif rCannonFireCount == 2 then
			electrics.values['rCannon3'] = 1
		end
	end
	
	if electrics.values['raise_cannons'] == 1 then
		if electrics.values['cannonPitch'] < 1 then
			electrics.values['cannonPitch'] = electrics.values['cannonPitch'] + 0.02
		elseif electrics.values['cannonPitch'] > 1 then
			electrics.values['cannonPitch'] = 1
		end
	elseif electrics.values['lower_cannons'] == 1 then
		if electrics.values['cannonPitch'] > -1 then
			electrics.values['cannonPitch'] = electrics.values['cannonPitch'] - 0.02
		elseif electrics.values['cannonPitch'] < -1 then
			electrics.values['cannonPitch'] = -1
		end
	end
		
	
	
	LastCannonPitch = electrics.values['cannonPitch']
	
	
	--print(lCannonFireCount)
end

M.onInit = onInit
M.onReset = onInit
M.updateGFX = onUpdate

return M